import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class Runner {

    public static void main(String[] args) throws SQLException {
        String host = args[0];
        String dbName = args[1];
        String username = args[2];
        String password = args[3];
        String url = "jdbc:mysql://" + host + ":3306/" + dbName + "?characterEncoding=UTF-8&useSSL=false&useJDBCCompliantTimezoneShift=true&useLegacyDatetimeCode=false&serverTimezone=UTC&allowPublicKeyRetrieval=true&cachePrepStmts=true&useServerPrepStmts=true";
        Connection connection = DriverManager.getConnection(url, username, password);

        PreparedStatement statement = connection.prepareStatement(
                "select `Receipt`.`outletId`, `ReceiptPayment`.`paymentTypeId`, `PaymentType`.`method`, " +
                        "date_format(`Receipt`.`TSCcreated`, '%Y-%m-%d %H:00:00') as `HourStartTime`, " +
                        "sum(case when `Receipt`.`type` = ? then ? else ? end) as `Transactions`, " +
                        "cast(sum(case when `Receipt`.`type` = ? then cast(ifnull(`ReceiptPayment`.`paymentTotal`, ?) as signed) else ? end) as signed) as `paymentAmount`, " +
                        "sum(case when `Receipt`.`type` = ? then ? else ? end) as `refundTransactions`," +
                        " cast(sum(case when `Receipt`.`type` = ? then cast(ifnull(`ReceiptPayment`.`paymentTotal`, ?) as signed) else ? end) as signed) as `refundAmount`, " +
                        "cast(sum(case when `Receipt`.`type` = ? then cast(ifnull(`ReceiptPayment`.`amountTips`, ?) as signed) else (? - `ReceiptPayment`.`amountTips`) end) as signed) as `tipsAmount`, " +
                        "cast(sum(case when `Receipt`.`type` = ? then cast(`RefIdToken`.`amountSurcharge` as signed) else (? - `RefIdToken`.`amountSurcharge`) end) as signed) as `amountSurcharge`" +
                        " from `Receipt` left outer join `ReceiptPayment` on `Receipt`.`id` = `ReceiptPayment`.`receiptId` " +
                        "left outer join `PaymentType` on `ReceiptPayment`.`paymentTypeId` = `PaymentType`.`id` " +
                        "left outer join `RefIdToken` on `ReceiptPayment`.`id` = `RefIdToken`.`receiptPaymentId` " +
                        "where (`Receipt`.`id` in (?) and (`Receipt`.`type` = ? or `Receipt`.`type` = ?)) " +
                        "group by `ReceiptPayment`.`paymentTypeId`, `Receipt`.`outletId`, ?"
        );

        statement.setString(1, "SALE");
        statement.setInt(2, 0);
        statement.setInt(3, 0);
        statement.setString(4, "SALE");
        statement.setInt(5, 0);
        statement.setInt(6, 0);
        statement.setString(7, "SALE");
        statement.setInt(8, 0);
        statement.setInt(9, 0);
        statement.setString(10, "SALE");
        statement.setInt(11, 0);
        statement.setInt(12, 0);
        statement.setString(13, "SALE");
        statement.setInt(14, 0);
        statement.setInt(15, 0);
        statement.setString(16, "SALE");
        statement.setInt(17, 0);
        statement.setInt(18, 1);
        statement.setString(19, "SALE");
        statement.setString(20, "REFUND");
        statement.setInt(21, 1);

        statement.executeQuery();
    }
}
